package com.emoon.knowledge.service.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.emoon.common.core.utils.MapstructUtils;
import com.emoon.common.core.utils.StringUtils;
import com.emoon.common.mybatis.core.page.PageQuery;
import com.emoon.common.mybatis.core.page.TableDataInfo;
import com.emoon.knowledge.domain.ThinkAskinfo;
import com.emoon.knowledge.domain.bo.ThinkAskinfoBo;
import com.emoon.knowledge.domain.vo.ThinkAskinfoVo;
import com.emoon.knowledge.mapper.ThinkAskinfoMapper;
import com.emoon.knowledge.service.IThinkAskinfoService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 请求记录Service业务层处理
 *
 * @author wangkang
 * @date 2025-11-26
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ThinkAskinfoServiceImpl implements IThinkAskinfoService {

    private final ThinkAskinfoMapper baseMapper;

    /**
     * 查询请求记录
     *
     * @param id 主键
     * @return 请求记录
     */
    @Override
    public ThinkAskinfoVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询请求记录列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 请求记录分页列表
     */
    @Override
    public TableDataInfo<ThinkAskinfoVo> queryPageList(ThinkAskinfoBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ThinkAskinfo> lqw = buildQueryWrapper(bo);
        Page<ThinkAskinfoVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的请求记录列表
     *
     * @param bo 查询条件
     * @return 请求记录列表
     */
    @Override
    public List<ThinkAskinfoVo> queryList(ThinkAskinfoBo bo) {
        LambdaQueryWrapper<ThinkAskinfo> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ThinkAskinfo> buildQueryWrapper(ThinkAskinfoBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ThinkAskinfo> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(ThinkAskinfo::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getToken()), ThinkAskinfo::getToken, bo.getToken());
        lqw.eq(StringUtils.isNotBlank(bo.getDecrypt()), ThinkAskinfo::getDecrypt, bo.getDecrypt());
        lqw.eq(StringUtils.isNotBlank(bo.getEncryption()), ThinkAskinfo::getEncryption, bo.getEncryption());
        lqw.eq(bo.getTime() != null, ThinkAskinfo::getTime, bo.getTime());
        lqw.eq(StringUtils.isNotBlank(bo.getReply()), ThinkAskinfo::getReply, bo.getReply());
        lqw.eq(StringUtils.isNotBlank(bo.getHisdata()), ThinkAskinfo::getHisdata, bo.getHisdata());
        return lqw;
    }

    /**
     * 新增请求记录
     *
     * @param bo 请求记录
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ThinkAskinfoBo bo) {
        ThinkAskinfo add = MapstructUtils.convert(bo, ThinkAskinfo.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改请求记录
     *
     * @param bo 请求记录
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ThinkAskinfoBo bo) {
        ThinkAskinfo update = MapstructUtils.convert(bo, ThinkAskinfo.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ThinkAskinfo entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除请求记录信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
